{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: "INI" controls 
//******************************************************
//******************************************************

unit INICtrl;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, DsgnIntf,INIMis,Menus,INIFile,ExtCtrls,
  Spin,Buttons,Mask,StdCtrls,INIUtil,INISec,INIEnt,
  ChkGroup;

type
	TCfgSeparator=class(TBevel)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgButton=class(TBitBtn)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgPaintBox=class(TPaintBox)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgSpinEdit=class(TSpinEdit)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Change; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgMaskEdit=class(TMaskEdit)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Change; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgShortCutEdit=class(TEditShortCut)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Change; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgEdit=class(TEdit)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Change; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgBinaryEdit=class(TMemo)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Change; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgColorEdit=class(TComboGetColor)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Change; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgCheckBox=class(TCheckBox)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Click; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgCheckBoxSC=class(TCheckBoxWithSC)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Click; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgRadioGroup=class(TRadioGroup)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Click; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgComboBox=class(TComboBox)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Change; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgListBox=class(TListBox)
	private
		FINIEntry:TINIEntry;

	protected
		procedure SetINIEntry(INIE:TINIEntry); virtual;
		procedure Click; override;

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntry read FINIEntry write SetINIEntry;
	end;

	TCfgCheckGroup=class(TCheckGroup)
	private
		FINIEntry:TINIEntryManyOfStrings;

	protected
		procedure SetINIEntry(INIE:TINIEntryManyOfStrings); virtual;

    procedure OnItemClick(Sender:TObject;NDX:LongInt;Checked:Boolean);

	public
		constructor Create(AOwner:TComponent); override;

		property INIEntry:TINIEntryManyOfStrings read FINIEntry write SetINIEntry;
	end;

	TCfgSubPanel=class(TPanel)
	public
		constructor Create(AOwner:TComponent); override;
	end;

implementation

procedure TCfgSeparator.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;
end;

constructor TCfgSeparator.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);

	Shape:=bsBox;
	Style:=bsRaised;
end;

procedure TCfgButton.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;
end;

constructor TCfgButton.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);

	Style:=bsNew;
end;

procedure TCfgPaintBox.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;
end;

constructor TCfgPaintBox.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);
end;

procedure TCfgSpinEdit.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;

	if Text<>INIE.AsString then Text:=INIE.AsString;
end;

procedure TCfgSpinEdit.Change; 
begin
	inherited Change;

	if INIEntry<>nil then INIEntry.AsString:=Text;
end;

constructor TCfgSpinEdit.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);
end;

procedure TCfgMaskEdit.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;

	if Text<>INIE.AsString then Text:=INIE.AsString;
end;

procedure TCfgMaskEdit.Change; 
begin
	inherited Change;

	if INIEntry<>nil then INIEntry.AsString:=Text;
end;

constructor TCfgMaskEdit.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);
end;

procedure TCfgShortCutEdit.SetINIEntry(INIE:TINIEntry); 
var sCut:string;
begin
	FINIEntry:=INIE;

	sCut:=ShortCutToText(TShortCut(INIE.AsInteger));

	if Text<>sCut then Text:=sCut;
end;

procedure TCfgShortCutEdit.Change; 
var Add:string;
begin
	inherited Change;

	if INIEntry<>nil then begin
		if (INIEntry as TINIEntryShortCut).EntryMenuItem<>nil then begin
			if Text<>'' then
				Add:=', '+Text
			else
				Add:='';

			((INIEntry as TINIEntryShortCut).EntryMenuItem.Control as TCfgCheckBoxSC).AddToCaption(Add);
		end;

		INIEntry.AsInteger:=TextToShortCut(Text);
	end;
end;

constructor TCfgShortCutEdit.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);
end;

procedure TCfgEdit.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;

	if Text<>INIE.AsString then Text:=INIE.AsString;
end;

procedure TCfgEdit.Change; 
begin
	inherited Change;

	if INIEntry<>nil then INIEntry.AsString:=Text;
end;

constructor TCfgEdit.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);
end;

procedure TCfgBinaryEdit.SetINIEntry(INIE:TINIEntry);
begin
	FINIEntry:=INIE;

	if Text<>INIE.AsString then Text:=INIE.AsString;
end;

procedure TCfgBinaryEdit.Change;
begin
	inherited Change;

	if INIEntry<>nil then INIEntry.AsString:=Text;
end;

constructor TCfgBinaryEdit.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);
end;

procedure TCfgColorEdit.SetINIEntry(INIE:TINIEntry);
var ii:LongInt;
begin
	FINIEntry:=INIE;

	ii:=Items.IndexOf(Copy(INIE.AsString,3,Length(INIE.AsString)-2));

  if ItemIndex<>ii then ItemIndex:=ii;
end;

procedure TCfgColorEdit.Change; 
begin
	inherited Change;

	if INIEntry<>nil then begin
  	if Text<>'' then INIEntry.AsInteger:=StringToColor('cl'+Text);
  end;
end;

constructor TCfgColorEdit.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);
end;

procedure TCfgCheckBox.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;

	if INIE.AsBoolean then
		State:=cbChecked
	else
		State:=cbUnChecked;
end;

procedure TCfgCheckBox.Click; 
begin
	inherited Click;

	if INIEntry<>nil then INIEntry.AsBoolean:=State=cbChecked;
end;

constructor TCfgCheckBox.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);
end;

procedure TCfgCheckBoxSC.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;

	if INIE.AsBoolean then
		State:=cbChecked
	else
		State:=cbUnChecked;
end;

procedure TCfgCheckBoxSC.Click; 
begin
	inherited Click;

	if INIEntry<>nil then INIEntry.AsBoolean:=State=cbChecked;
end;

constructor TCfgCheckBoxSC.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);
end;

procedure TCfgRadioGroup.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;

	if ItemIndex<>INIE.AsInteger then ItemIndex:=INIE.AsInteger;
end;

procedure TCfgRadioGroup.Click; 
begin
	inherited Click;

	if INIEntry<>nil then INIEntry.AsInteger:=ItemIndex;
end;

constructor TCfgRadioGroup.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);

	Caption:='';
end;

procedure TCfgComboBox.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;

	if ItemIndex<>INIE.AsInteger then ItemIndex:=INIE.AsInteger;
end;

procedure TCfgComboBox.Change; 
begin
	inherited Change;

	if INIEntry<>nil then INIEntry.AsInteger:=ItemIndex;
end;

constructor TCfgComboBox.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);
  
	Style:=csDropDownList;
end;

procedure TCfgListBox.SetINIEntry(INIE:TINIEntry); 
begin
	FINIEntry:=INIE;

	if ItemIndex<>INIE.AsInteger then ItemIndex:=INIE.AsInteger;
end;

procedure TCfgListBox.Click; 
begin
	inherited Click;

	if INIEntry<>nil then INIEntry.AsInteger:=ItemIndex;
end;

constructor TCfgListBox.Create(AOwner:TComponent); 
begin
	inherited Create(AOwner);

	Style:=lbOwnerDrawFixed;
end;

procedure TCfgCheckGroup.SetINIEntry(INIE:TINIEntryManyOfStrings);
var i:Integer;
begin
	FINIEntry:=INIE;

  for i:=0 to Items.Count-1 do
  	if FINIEntry.Checked[i] then
    	CheckItem(i)
    else
    	UnCheckItem(i);
end;

procedure TCfgCheckGroup.OnItemClick(Sender:TObject;NDX:LongInt;Checked:Boolean);
begin
	FINIEntry.Checked[NDX]:=Checked;
end;

constructor TCfgCheckGroup.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);

  BorderStyle:=bsSingle;
  OnCheckBoxClick:=OnItemClick;
end;

constructor TCfgSubPanel.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);

	BevelInner:=bvNone;
	BevelOuter:=bvNone;
	BorderWidth:=0;
	Caption:='';
end;

end.