{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Some standard controls with auto-save state feature
//******************************************************
//******************************************************

unit INIExCt;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, ExtCtrls,INIMis,INIUtil,INIEnt;

type
	TLineForResizingStateSaved = class(TLineForResizing)
  private
  	FEntry:TINIEntryInteger;

    procedure SetEntry(INIE:TINIEntryInteger);

  protected
    procedure NotifyFinnished; override;
    procedure Loaded; override;

		procedure Notification(AComponent:TComponent;Operation:TOperation); override;

	public
		constructor Create(AOwner:TComponent); override;

  published
  	property Entry:TINIEntryInteger read FEntry write SetEntry;
  end;

implementation

procedure TLineForResizingStateSaved.NotifyFinnished;
begin
	inherited NotifyFinnished;

  if (FEntry<>nil) and (FResizeControl<>nil) then begin
	  if Direction=rdHorizontal then
	  	FEntry.AsInteger:=FResizeControl.Width
    else
	  	FEntry.AsInteger:=FResizeControl.Height;
  end;
end;

procedure TLineForResizingStateSaved.Loaded;
begin
	inherited Loaded;

  if not (csDesigning in ComponentState) then begin
    if (FEntry<>nil) and (FResizeControl<>nil) then begin
      if Direction=rdHorizontal then
        FResizeControl.Width:=FEntry.AsInteger
      else
        FResizeControl.Height:=FEntry.AsInteger;
    end;
  end;
end;

procedure TLineForResizingStateSaved.SetEntry(INIE:TINIEntryInteger);
begin
	FEntry:=INIE;

  if FEntry<>nil then with FEntry do begin
	  if Direction=rdHorizontal then
  		IMinValue:=MinW
    else
  		IMinValue:=MinH;
  end;
end;

procedure TLineForResizingStateSaved.Notification(AComponent:TComponent;Operation:TOperation);
begin
	inherited Notification(AComponent,Operation);

	if Operation=opRemove then begin
  	if AComponent=FEntry then FEntry:=nil;
  end;
end;

constructor TLineForResizingStateSaved.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);

  FEntry:=nil;
end;

end.
