{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: Form for searching section in section list
//******************************************************
//******************************************************

unit INIFindS;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, INIUtil, ExtCtrls, FSaver,INISec,
  Menus, INISecEx, INISaver, INIEnt;

type
  TfrmGetSection = class(TFormSearchMultiSection)
    Panel2: TPanel;
    pnlButtons: TAutoAlignPanel;
    BBOk: TBitBtn;
    BBCancel: TBitBtn;
    Panel1: TPanel;
    BBHelp: TBitBtn;
    popMenu: TPopupMenu;
    MISyncronize: TMenuItem;
    MIStayOnTop: TMenuItem;
    LV: TListViewExtended;
    INIDatabase: TINIDatabase;
    INIFormSaver: TINIFormSaver;
    secFormSaver: TINIMultiSectionFormSaver;
    secFindSectionState: TINISection;
    secFindSectionStateStayOnTop: TINIEntryBoolean;
    secFindSectionStateSyncronize: TINIEntryBoolean;
    procedure LVChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure FormShow(Sender: TObject);
    procedure LVKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BBHelpClick(Sender: TObject);
    procedure MISyncronizeClick(Sender: TObject);
    procedure BBCancelClick(Sender: TObject);
    procedure BBOkClick(Sender: TObject);
    procedure MIStayOnTopClick(Sender: TObject);
    procedure INIDatabaseBeforeWrite(Sender: TObject);
  private
  	FReadValues:Boolean;
  	FMultiSection:TINICustomMultiSection;
    FParentControl:TControl;
    FSelected:LongInt;

		function AddLVColumn(const Caption:string):TListColumn;
		function AddLVItem(const Caption:string;SubCaptions:array of string):TListItem;

    procedure AddColumns(Section:TINICustomSection);
    procedure AddItems(Section:TINICustomSection);

		procedure SetStayOnTop;

  protected
		procedure WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure Notification(AComponent:TComponent;Operation:TOperation); override;

  public
  	function Go(MultiSection:TINICustomMultiSection;ParentControl:TControl):Word; override;
  end;

var
  frmGetSection: TfrmGetSection;

implementation

uses INIMis;

{$R *.DFM}

function TfrmGetSection.AddLVColumn(const Caption:string):TListColumn;
var LC:TListColumn;
begin
	LC:=LV.Columns.Add;

  LC.Caption:=Caption;
  LC.Width:=ColumnHeaderWidth;

  Result:=LC;
end;

function TfrmGetSection.AddLVItem(const Caption:string;SubCaptions:array of string):TListItem;
var LI:TListItem;
		i:Integer;
begin
	LI:=LV.Items.Add;

  LI.Caption:=Caption;

  for i:=Low(SubCaptions) to High(SubCaptions) do
	  LI.SubItems.Add(SubCaptions[i]);

  Result:=LI;
end;

procedure TfrmGetSection.AddColumns(Section:TINICustomSection);
var i,fc:Integer;
		sSection:TINICustomSection;
begin
	if Section<>nil then begin
    fc:=Section.FieldCount-1;

    for i:=0 to fc do begin
      if Section.Fields[i] is TINIEntryStreamed then begin
      	if (Section.Fields[i] as TINIEntryStreamed).ShowInGrid then AddLVColumn(Section.Fields[i].DisplayLabel);
      end else if Section.Fields[i] is TINIEntrySubSection then begin
      	sSection:=(Section.Fields[i] as TINIEntrySubSection).SubSection;

        if (sSection<>nil) and (sSection is TINICustomMultiSection) then
        	AddLVColumn(sSection.SectionName)
        else
        	AddColumns(sSection);
      end;
    end;
  end;
end;

procedure TfrmGetSection.AddItems(Section:TINICustomSection);
var i,sc:Integer;
		LI:TListItem;

	procedure AddSubItems(Section:TINICustomSection);
  var i,fc:Integer;
  		sSection:TINICustomSection;
  begin
  	if Section<>nil then begin
      fc:=Section.FieldCount-1;

      for i:=0 to fc do begin
        if Section.Fields[i] is TINIEntryStreamed then begin
	      	if (Section.Fields[i] as TINIEntryStreamed).ShowInGrid then LI.SubItems.Add(Section.Fields[i].AsString);
        end else if Section.Fields[i] is TINIEntrySubSection then begin
          sSection:=(Section.Fields[i] as TINIEntrySubSection).SubSection;

          if (sSection<>nil) and (sSection is TINICustomMultiSection) then
            LI.SubItems.Add((sSection as TINICustomMultiSection).Key)
          else
            AddSubItems(sSection);
        end;
      end;
    end;
  end;

begin
	sc:=FMultiSection.KeyCount-1;

	LV.AllocBy:=sc;

  if FReadValues then FMultiSection.BeginWalk;

  try
    for i:=0 to sc do begin
    	if FReadValues then begin
	      FMultiSection.KeyIndex:=i;

  	    LI:=LV.Items.Add;
    	  LI.Caption:=FMultiSection.Key;

      	AddSubItems(FMultiSection);
      end else begin
  	    LI:=LV.Items.Add;
    	  LI.Caption:=FMultiSection.KeyByIndex[i];
      end;
    end;

    finally
		  if FReadValues then FMultiSection.EndWalk;
  end;
end;

function TfrmGetSection.Go(MultiSection:TINICustomMultiSection;ParentControl:TControl):Word;
begin
	FSelected:=MultiSection.KeyIndex;

	FMultiSection:=MultiSection;
  FParentControl:=ParentControl;

  INIDatabase.FileName:=FMultiSection.FileName;
  INIDatabase.Destination:=FMultiSection.Destination;

  secFormSaver.ParentDestination:=True;
  secFindSectionState.ParentDestination:=True;
  
  INIDatabase.Read;

  INIFormSaver.SetFormPos(Self);

  MIStayOnTop.Checked:=secFindSectionStateStayOnTop.AsBoolean;
  MISyncronize.Checked:=secFindSectionStateSyncronize.AsBoolean;

  SetStayOnTop;

  if FMultiSection<>nil then begin
    if FParentControl<>nil then
      FParentControl.FreeNotification(Self)
    else
      MultiSection.FreeNotification(Self);

    LV.Items.BeginUpdate;

    LV.Columns.Clear;
    LV.Items.Clear;

    try
      AddLVColumn(FMultiSection.SectionName);

      AddColumns(FMultiSection);

      FReadValues:=LV.Columns.Count>1;

      AddItems(FMultiSection);

      finally
        LV.Items.EndUpdate;
    end;

    Show;
  end;

  Result:=mrOK;
end;

procedure TfrmGetSection.LVChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
	if MISyncronize.Checked then begin
  	if LV.Selected<>nil then begin
    	FMultiSection.Key:=LV.Selected.Caption;
      FMultiSection.RefreshControls;
    end;
  end;
end;

procedure TfrmGetSection.FormShow(Sender: TObject);
begin
	if LV.Items.Count>0 then begin
  	LV.SetFocus;

    if (FSelected>=0) and (FSelected<LV.Items.Count) then begin
      LV.Items[FSelected].MakeVisible(True);
	    LV.Items[FSelected].Selected:=True;
  	  LV.Items[FSelected].Focused:=True;
    end;
  end;
end;

procedure TfrmGetSection.LVKeyPress(Sender: TObject; var Key: Char);
begin
	if Key=#13 then begin
  	Key:=#0;

    ModalResult:=mrOK;
  end;
end;

procedure TfrmGetSection.WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo);
begin
	inherited;

  with Msg.MinMaxInfo^.ptMinTrackSize do begin
  	x:=200;
    y:=120;
  end;
end;

procedure TfrmGetSection.FormResize(Sender: TObject);
begin
  pnlButtons.Width:=Min(250,Self.ClientWidth);
end;

procedure TfrmGetSection.FormCreate(Sender: TObject);
begin
	FSelected:=-1;

	FMultiSection:=nil;
  FParentControl:=nil;
  
	FReadValues:=True;
end;

procedure TfrmGetSection.BBHelpClick(Sender: TObject);
begin
	Application.HelpJump('SearchSection');
end;

procedure TfrmGetSection.MISyncronizeClick(Sender: TObject);
begin
	MISyncronize.Checked:=not MISyncronize.Checked;
end;

procedure TfrmGetSection.Notification(AComponent:TComponent;Operation:TOperation);
begin
	inherited Notification(AComponent,Operation);

  if Operation=opRemove then begin
  	if AComponent=FMultiSection then begin
    	FMultiSection:=nil;

    	Close;
    end else if AComponent=FParentControl then begin
    	FMultiSection:=nil;

    	Close;
    end;
  end;
end;

procedure TfrmGetSection.BBCancelClick(Sender: TObject);
begin
	Close;
end;

procedure TfrmGetSection.BBOkClick(Sender: TObject);
begin
  INIDatabase.Write;

	if (LV.Selected<>nil) and (FMultiSection<>nil) then begin
  	FMultiSection.Key:=LV.Selected.Caption;
    FMultiSection.RefreshControls;
  end;

  Close;
end;

procedure TfrmGetSection.MIStayOnTopClick(Sender: TObject);
begin
	MIStayOnTop.Checked:=not MIStayOnTop.Checked;

  SetStayOnTop;
end;

procedure TfrmGetSection.SetStayOnTop;
begin
  if MIStayOnTop.Checked then begin
  	if FormStyle<>fsStayOnTop then FormStyle:=fsStayOnTop;
  end else begin
  	if FormStyle<>fsNormal then FormStyle:=fsNormal;
  end;
end;

procedure TfrmGetSection.INIDatabaseBeforeWrite(Sender: TObject);
begin
  secFindSectionStateStayOnTop.AsBoolean:=MIStayOnTop.Checked;
  secFindSectionStateSyncronize.AsBoolean:=MISyncronize.Checked;
end;

initialization
	INISec.FormSearchMultiSectionClass:=TfrmGetSection;
end.

